# [Le Biniou](https://biniou.net)

[![pipeline status](https://gitlab.com/lebiniou/lebiniou/badges/master/pipeline.svg)](https://gitlab.com/lebiniou/lebiniou/commits/master)

# Installation

## On a Debian GNU/Linux-based system

  1. Install required dependencies

  ```sh
  $ sudo apt-get -qq update
  $ sudo apt-get -qq install autoconf pkg-config gcc make libglib2.0-dev libfftw3-dev libxml2-dev libfreetype6-dev libswscale-dev libsdl1.2-dev libsdl-ttf2.0-dev libpnglite-dev libcaca-dev libjack-dev
  ```

  2. Configure, compile and install

  ```sh
  $ autoreconf -i
  $ ./configure
  $ make
  $ sudo make install
  ```

  3. Follow the same steps for [lebiniou-data](https://gitlab.com/lebiniou/lebiniou-data) package, then

  4. Run

  ```sh
  $ lebiniou
  ```

  5. Get more options
  ```sh
  $ lebiniou --help
  $ man lebiniou
  ```

## On other Linux or BSD-based systems

  1. Pull necessary dependencies
  
  2. Same procedure, just add the `--with-pnglite` flag to configure

  ```sh
  $ autoreconf -i
  $ ./configure --with-pnglite
  $ make
  $ sudo make install
  ```
