/*
 *  Copyright 1994-2018 Olivier Girondel
 *
 *  This file is part of lebiniou.
 *
 *  lebiniou is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  lebiniou is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with lebiniou. If not, see <http://www.gnu.org/licenses/>.
 */

#include "context.h"


u_long id = 944355802;
u_long options = BE_BLUR;
char desc[] = "Blur filter";


void
run(Context_t *ctx)
{
  Pixel_t *d;
  const Buffer8_t *src = active_buffer(ctx);
  Buffer8_t *dst = passive_buffer(ctx);
  const Pixel_t *m = src->buffer;
  const Pixel_t *n = src->buffer + WIDTH;
  const Pixel_t *o = src->buffer + (2 * WIDTH);
  long i;

  Buffer8_init_mask_3x3(active_buffer(ctx));

  d = dst->buffer + (WIDTH + 1);
  for (i = BUFFSIZE - WIDTH - (WIDTH + 1) - 1; i--; m++, n++, o++)
    *d++ = (*m + (*(m + 1) << 1) + (*m + 2)
	    + (*n << 1) + (*(n + 1) << 4) + (*(n + 2) << 1)
	    + *o + (*(o + 1) << 1) + *(o + 2)) >> 5;

  Buffer8_expand_border(dst);
}
